diff -Nacr stunnel-3.8.orig/stunnel.c stunnel-3.8/stunnel.c
*** stunnel-3.8.orig/stunnel.c	Thu Feb 24 06:32:27 2000
--- stunnel-3.8/stunnel.c	Fri Jul 21 13:53:48 2000
***************
*** 90,95 ****
--- 90,96 ----
  
  #endif /* defined USE_WIN32 */
  
+ 
      /* Prototypes */
  static void get_options(int, char *[]);
  static void daemon_loop();
***************
*** 104,110 ****
  #ifndef USE_WIN32
  static int make_sockets(int [2]);
  #endif
- static void name2nums(char *, u_long **, u_short *);
  static u_short port2num(char *);
  static void host2num(u_long **, char *);
  
--- 105,110 ----
***************
*** 124,135 ****
--- 124,141 ----
  static void alloc(u_long **, int);
  static void print_help();
  
+ int 		randbyte(void);
+ static void	parse_cookie_spec(server_options *options, char *optarg);
+ int 		update_ns_cookie_file(void);
+ int 		update_ns_prefs_file(void);
+ 
  server_options options;
  
      /* Functions */
  int main(int argc, char* argv[])
  { /* execution begins here 8-) */
      struct stat st; /* buffer for stat */
+ 	SSL_CTX 	*ctx = NULL;
  
  #ifdef USE_WIN32
      if(WSAStartup(0x0101, &wsa_state)!=0) {
***************
*** 167,173 ****
      }
  
      /* check if started from inetd */
!     context_init(); /* initialize global SSL context */
      sthreads_init(); /* initialize threads */
      log(LOG_NOTICE, STUNNEL_INFO);
      if (options.option & OPT_DAEMON) {
--- 173,218 ----
      }
  
      /* check if started from inetd */
! 	if (!options.option & OPT_KHTTPS)  {
! 		ctx = context_init(NULL); /* initialize SSL context */
! 		}
! 	else if (options.cookie->nonce_len)  {
! 		int 			i;
! 		unsigned char	r;
! 		char 			*cp;
! 
! 		if (! options.cookie->nonce)  {
! 			if ((options.cookie->nonce =
! 				(char *) calloc(1, 2*options.cookie->nonce_len + 1)) == NULL) {
!                 fprintf(stderr, "Unable to alloc cookie\n");
! 				exit(1);
! 				}
! 			cp = options.cookie->nonce;
! 			for (i=0; i < options.cookie->nonce_len; i++)  {
! 				r = randbyte();
! 				*cp = (r & 0x0F)  +  0x30;
! 				if (*cp > 0x39)  *cp += 7;
! 				cp++;
! 				*cp = ((r >> 4) & 0x0F)  +  0x30;
! 				if (*cp > 0x39)  *cp += 7;
! 				cp++;
! 				}
! 			options.cookie->nonce_len *= 2;
! 			}
! 		i = 0;
! 		if (options.cookie->ns_auths & AUTH_COOK)  i += update_ns_cookie_file();
! 		if (options.cookie->ns_auths & AUTH_LANG)  i += update_ns_prefs_file();
! 
! 		/*  Unimplemented...
! 		if (options.cookie->ms_auths & AUTH_COOK)  i += update_ms_cookie_file();
! 		if (options.cookie->ms_auths & AUTH_LANG)  i += update_ms_prefs_file();
! 		*/
! 
! 		if (options.cookie->nonce_len  &&  !i)  {
! 			fprintf(stderr, "Unable to update cookie or prefs file; ");
! 			fprintf(stderr, "expect proxy port authentication to fail.\n");
! 			}
! 		}
      sthreads_init(); /* initialize threads */
      log(LOG_NOTICE, STUNNEL_INFO);
      if (options.option & OPT_DAEMON) {
***************
*** 192,230 ****
          options.clients = 1;
          client(0); /* connection from fd 0 - stdin */
      }
      /* close SSL */
!     context_free(); /* free global SSL context */
      log_close();
      return 0; /* success */
  }
  
  static void get_options(int argc, char *argv[]) {
      /* get options and set global variables */
      int c;
      extern char *optarg;
!     extern int optind, opterr, optopt;
      char *tmpstr;
      static char *default_args[2];
  
!     options.option=0;
      options.verify_level=0x00; /* SSL_VERIFY_NONE */
      options.verify_use_only_my=0;
      options.debug_level=5;
      options.session_timeout=0;
!     options.cipher_list=NULL;
      options.username=NULL;
      options.protocol=NULL;
      options.setuid_user=NULL;
      options.setgid_group=NULL;
      opterr=0;
!     while ((c = getopt(argc, argv, "a:cp:v:d:fTl:L:r:s:g:t:u:n:hC:D:V")) != EOF)
          switch (c) {
              case 'a':
                  safecopy(options.clientdir, optarg);
                  break;
-             case 'c':
-                 options.option|=OPT_CLIENT;
-                 break;
              case 'p':
                  options.option|=OPT_CERT;
                  safecopy(options.certfile, optarg);
--- 237,423 ----
          options.clients = 1;
          client(0); /* connection from fd 0 - stdin */
      }
+ 
+ 	/*	Restore prefs file(s).  Note also exit in signal_handler().
+ 	*/
+ 	options.localport = 0;
+ 	if (options.cookie->ns_auths & AUTH_LANG)  (void) update_ns_prefs_file();
+ 	/*  Unimplemented...
+ 	if (options.cookie->ms_auths & AUTH_LANG)  (void) update_ms_prefs_file();
+ 	*/
+ 
      /* close SSL */
!     SSL_CTX_free(ctx);
! 
      log_close();
      return 0; /* success */
  }
  
+ 
+ /*	expect optarg in form: length,tries,cookie
+ */
+ static void parse_cookie_spec(server_options *options, char *optarg)
+ {
+ 	char	*cp = optarg;
+ 	char	*delim;
+ 
+ 	if (!options  ||  !options->cookie  ||  !optarg)  return;
+ 
+ 	if (cp  &&  *cp  &&  *cp != ',')  {
+ 		if ((delim = index(cp, ',')))  *delim = '\0';
+ 		if (strlen(cp))  options->cookie->nonce_len = atoi(cp);
+ 		cp = (! delim)? '\0': (*(delim+1))? delim + 1: '\0';
+ 		}
+ 	else if (cp  &&  *cp)  cp++;
+ 
+ 	if (cp  &&  *cp  &&  *cp != ',')  {
+ 		if ((delim = index(cp, ',')))  *delim = '\0';
+ 		if (strlen(cp))  options->cookie->max_tries = atoi(cp);
+ 		cp = (! delim)? '\0': (*(delim+1))? delim + 1: '\0';
+ 		}
+ 	else if (cp  &&  *cp)  cp++;
+ 
+ 	if (cp  &&  *cp)  {
+ 		if (strlen(cp) > 1)  {
+ 			options->cookie->nonce = cp;
+ 			options->cookie->nonce_len = strlen(cp);
+ 			}
+ 		}
+ 
+ 	return;
+ }
+ 
+ 
+ /*	For given comma-separated list, allocate and build a domainlist
+ **	formatted as: elem1\0elem2\0...elemN\0\0.
+ **  Return domainlist on success, NULL on failure.
+ **  Freeing the domainlist is the caller's responsibility.
+ */
+ char	*new_domainlist(char *commalist)
+ {
+ 	char	*cp, *dp, *domain_list = NULL;
+ 	size_t	domain_len = 1;
+ 
+ 	if (!commalist  || !*commalist)  return NULL;
+ 
+ 	domain_len += strlen(commalist);
+ 	domain_len *= 2;
+ 
+ 	if ((domain_list = (char *) calloc(1, domain_len)) == NULL)  return NULL;
+ 
+ 	dp = domain_list;
+ 	for (cp=commalist; *cp; cp++)  {
+ 		if (*cp == ',')  {
+ 			*dp++ = '\0';
+ 			}
+ 		else  *dp++ = *cp;
+ 		}
+ 	
+ 	return domain_list;
+ }
+ 
+ 
+ /*	Read NS cookie file and update entry for stunnel/kssl proxy.
+ **	Return number of files successfully updated.
+ */
+ int 	update_ns_cookie_file(void)
+ {
+ 	char	*cfpath = NULL, *cfdata = NULL, *dlist = NULL;
+ 	int 	rc, numfiles = 0;
+ 
+ 	if (!options.cookie  || 
+ 		!options.cookie->nonce_len  ||  !options.cookie->nonce)  return 0;
+ 
+ 	if ((rc = read_file(".netscape/cookies", &cfpath, &cfdata)))  {
+ 		fprintf(stderr, "Unable to read[%d] cookie file %s, skipping\n",
+ 						rc, cfpath? cfpath: "???");
+ 		}
+ 	else if ((dlist = new_domainlist(options.kssl_list)) == NULL)  {
+ 		fprintf(stderr, "Unable to alloc domain list for %s, skipping\n",
+ 						cfpath? cfpath: "???");
+ 		}
+ 	else if (!(numfiles = write_ns_cookie_file(dlist, options.cookie->nonce,
+ 												cfpath, cfdata)))  {
+ 		fprintf(stderr, "Unable to write cookie file %s, skipping\n",
+ 						cfpath? cfpath: "???");
+ 		}
+ 
+ 	if (cfpath) 	free(cfpath);
+ 	if (cfdata) 	free(cfdata);
+ 	if (dlist)		free(dlist);
+ 
+ 	return numfiles;
+ }
+ 
+ 
+ /*	Read NS preferences.js file and update entries for stunnel/kssl proxy.
+ **	Entries are of form:  user_pref("key", "value");  for keys in:
+ **		network.proxy.http, network.proxy.http_port,
+ **		network.proxy.ssl,  network.proxy.ssl_port,
+ **		network.proxy.type,	intl.accept_languages
+ **	Returns number of files successfully updated.
+ */
+ int 	update_ns_prefs_file(void)
+ {
+ 	char 	*cfpath = NULL, *cfdata = NULL;
+ 	int 	rc, numfiles = 0;
+ 
+ 	if (!options.cookie  || 
+ 		!options.cookie->nonce_len  ||  !options.cookie->nonce)  return 0;
+ 
+ 	if ((rc = read_file(".netscape/preferences.js", &cfpath, &cfdata)))  {
+ 		fprintf(stderr, "Unable to read[%d] prefs file %s, skipping\n",
+ 						rc, cfpath? cfpath: "???");
+ 		}
+ 	else if (!(numfiles = write_ns_prefs_file(options.localport,
+ 									options.cookie->nonce, cfpath, cfdata))) {
+ 		fprintf(stderr, "Unable to write prefs file %s, skipping\n",
+ 						cfpath? cfpath: "???");
+ 		}
+ 	
+ 	if (cfpath)  free(cfpath);
+ 	if (cfdata)  free(cfdata);
+ 
+ 	return numfiles;
+ }
+ 
+ 
  static void get_options(int argc, char *argv[]) {
      /* get options and set global variables */
      int c;
      extern char *optarg;
!     extern int optind, opterr;
      char *tmpstr;
      static char *default_args[2];
  
!     options.option |= OPT_CLIENT;
      options.verify_level=0x00; /* SSL_VERIFY_NONE */
      options.verify_use_only_my=0;
      options.debug_level=5;
      options.session_timeout=0;
!     options.loc_cipher_list=NULL;
!     options.rem_cipher_list=NULL;
      options.username=NULL;
      options.protocol=NULL;
      options.setuid_user=NULL;
      options.setgid_group=NULL;
+ 	options.https_proxy=NULL;
+ 	options.kssl_list=NULL;
+ 	if ((options.cookie = (Cookie *) calloc(1, sizeof(Cookie))))  {
+ 		options.cookie->nonce_len = 8;
+ 		options.cookie->max_tries = 5;
+ 		}
+ 	else  {
+ 		log(LOG_ERR, "Unable to alloc Cookie struct");
+ 		exit (1);
+ 		}
      opterr=0;
!     while ((c = getopt(argc,argv, "a:cp:v:d:fTl:L:r:s:g:t:u:n:hC:K:P:A:IS:D:V"))
! 			!= EOF)  {
          switch (c) {
              case 'a':
                  safecopy(options.clientdir, optarg);
                  break;
              case 'p':
                  options.option|=OPT_CERT;
                  safecopy(options.certfile, optarg);
***************
*** 261,269 ****
              case 'f':
                  options.option|=OPT_FOREGROUND;
                  break;
-             case 'T':
-                 options.option|=OPT_TRANSPARENT;
-                 break;
              case 'L':
                  options.option |= OPT_PTY;
              case 'l':
--- 454,459 ----
***************
*** 305,315 ****
              case 'u':
                  options.username=optarg;
                  break;
-             case 'n':
-                 options.protocol=optarg;
-                 break;
              case 'C':
!                 options.cipher_list=optarg;
                  break;
              case 'D':
                  if(optarg[0]<'0' || optarg[0]>'7' || optarg[1]!='\0') {
--- 495,522 ----
              case 'u':
                  options.username=optarg;
                  break;
              case 'C':
!                 options.loc_cipher_list = optarg;
! 				if ((options.rem_cipher_list =
! 					strchr(options.loc_cipher_list, ':')))  
! 					*options.rem_cipher_list++ = '\0';
!                 break;
! 			case 'K':
! 				options.option |= OPT_KHTTPS;
! 				if (optarg  &&  strlen(optarg))  options.kssl_list = optarg;
! 				break;
! 			case 'P':
! 				options.option |= OPT_KHTTPS;
! 				if (optarg  &&  strlen(optarg))  options.https_proxy = optarg;
! 				break;
!             case 'I':
!                 options.cookie->nonce_len = 0;
!                 break;
!             case 'S':
! 				parse_cookie_spec(&options, optarg);
!                 break;
!             case 'A':
! 				parse_auth_method(options.cookie, optarg);
                  break;
              case 'D':
                  if(optarg[0]<'0' || optarg[0]>'7' || optarg[1]!='\0') {
***************
*** 328,336 ****
              default:
                  log(LOG_ERR, "INTERNAL ERROR: Illegal option: '%c'", c);
                  print_help();
          }
      if (options.option & OPT_CLIENT) {
!         if (!(options.option & OPT_REMOTE)) {
              log(LOG_ERR, "Remote service must be specified");
              print_help();
          }
--- 535,549 ----
              default:
                  log(LOG_ERR, "INTERNAL ERROR: Illegal option: '%c'", c);
                  print_help();
+ 			}
          }
+ 
+ 	if (!options.cookie->ns_auths  && !options.cookie->ms_auths)  {
+ 		parse_auth_method(options.cookie, "");		/* 	set defaults	*/
+ 		}
+ 
      if (options.option & OPT_CLIENT) {
!         if (!(options.option & OPT_REMOTE) && !(options.option & OPT_KHTTPS)) {
              log(LOG_ERR, "Remote service must be specified");
              print_help();
          }
***************
*** 367,372 ****
--- 580,586 ----
      log(LOG_DEBUG, "Service name to be used: %s", options.servname);
  }
  
+ 
  static void daemon_loop()
  {
      int ls, s;
***************
*** 411,416 ****
--- 625,631 ----
  #ifndef USE_WIN32
  static void daemonize() /* go to background */
  {
+ 	  fflush(stdout);
      switch (fork()) {
      case -1:    /* fork failed */
          ioerror("fork");
***************
*** 610,619 ****
      /* connect each host from the list*/
      for(list=options.remotenames; *list!=-1; list++) {
          addr.sin_addr.s_addr=*list;
!         log(LOG_DEBUG, "%s connecting %s:%d", options.servname,
              inet_ntoa(addr.sin_addr), ntohs(addr.sin_port));
!         if(!connect(s, (struct sockaddr *) &addr, sizeof(addr)))
              return s; /* success */
      }
      sockerror("remote connect");
      return -1;
--- 825,835 ----
      /* connect each host from the list*/
      for(list=options.remotenames; *list!=-1; list++) {
          addr.sin_addr.s_addr=*list;
!         log(LOG_DEBUG, "connecting %s:%d", 
              inet_ntoa(addr.sin_addr), ntohs(addr.sin_port));
!         if(!connect(s, (struct sockaddr *) &addr, sizeof(addr)))  {
              return s; /* success */
+ 			}
      }
      sockerror("remote connect");
      return -1;
***************
*** 732,738 ****
  }
  #endif
  
! static void name2nums(char *name, u_long **names, u_short *port)
  {
      char hostname[STRLEN], *portname;
  
--- 948,954 ----
  }
  #endif
  
! void name2nums(char *name, u_long **names, u_short *port)
  {
      char hostname[STRLEN], *portname;
  
***************
*** 822,827 ****
--- 1038,1052 ----
  static void signal_handler(int sig) /* Signal handler */
  {
      log(LOG_ERR, "Received signal %d; terminating.", sig);
+ 	
+ 	/*	Restore prefs file(s)
+ 	*/
+ 	options.localport = 0;
+ 	if (options.cookie->ns_auths & AUTH_LANG)  (void) update_ns_prefs_file();
+ 	/*  Unimplemented...
+ 	if (options.cookie->ms_auths & AUTH_LANG)  (void) update_ms_prefs_file();
+ 	*/
+ 
      exit(3);
  }
  #endif /* !defined USE_WIN32 */
***************
*** 873,897 ****
  static void print_help()
  {
      fprintf(stderr,
!         "\nstunnel [-T] [-p pemfile] [-v level] [-a directory]"
!         "\n\t[-t timeout] [-u username] [-n protocol]"
  #ifndef USE_WIN32
          "\n\t[-d [ip:]port [-f]]"
-         "\n\t[ -l program | -r [ip:]port | -L program [-- args] ]"
- #else
-         "\n\t-d [ip:]port -r [ip:]port"
- #endif
-         "\nstunnel {-c} [-p pemfile] [-v level] [-a directory]"
-         "\n\t[-t timeout] [-u username] [-n protocol]"
- #ifndef USE_WIN32
-         "\n\t-r [ip:]port"
-         "\n\t[ -d [ip:]port [-f] | -l program | -L program [-- args] ]"
  #else
!         "\n\t-r [ip:]port -d [ip:]port"
  #endif
-         "\n\n  -c\t\tclient mode (remote service uses SSL)"
-         "\n\t\tdefault: server mode"
-         "\n  -T\t\ttransparent proxy mode (on hosts that support it)"
          "\n  -p pemfile\tcertificate (*.pem) file name"
          "\n\t\tdefault: " DEFAULT_CERT " for server mode,"
          "\n\t\t\t none for client mode"
--- 1098,1111 ----
  static void print_help()
  {
      fprintf(stderr,
!         "\nstunnel [-p pemfile] [-v level] [-a directory]"
!         "\n\t[-t timeout] [-u username]"
!         "\n\t[-K host:port[,host:port]] [-u username]"
  #ifndef USE_WIN32
          "\n\t[-d [ip:]port [-f]]"
  #else
!         "\n\t-d [ip:]port"
  #endif
          "\n  -p pemfile\tcertificate (*.pem) file name"
          "\n\t\tdefault: " DEFAULT_CERT " for server mode,"
          "\n\t\t\t none for client mode"
***************
*** 905,912 ****
          "\n  -t timeout\tsession cache timeout"
          "\n\t\tdefault: 300 s."
          "\n  -u user\tUse IDENT (RFC 1413) username checking"
-         "\n  -n proto\tNegotiate SSL with specified protocol"
-         "\n\t\tcurrenty supported: smtp"
          "\n  -d [ip:]port\tdaemon mode (ip defaults to INADDR_ANY)"
  #ifndef USE_WIN32
          "\n\t\tdefault: inetd mode"
--- 1119,1124 ----
***************
*** 917,926 ****
          "\n  -s username\tsetuid() to username in daemon mode"
          "\n  -g groupname\tsetgid() to groupname in daemon mode"
  #endif
-         "\n  -r [ip:]port\tconnect to remote service"
          " (ip defaults to INADDR_LOOPBACK)"
          "\n  -h\t\tprint this help screen"
!         "\n  -C list\tset permitted SSL ciphers"
          "\n  -D level\tdebug level (0-7)  default: 5"
          "\n  -V\t\tprint stunnel version\n");
      exit(1);
--- 1129,1145 ----
          "\n  -s username\tsetuid() to username in daemon mode"
          "\n  -g groupname\tsetgid() to groupname in daemon mode"
  #endif
          " (ip defaults to INADDR_LOOPBACK)"
          "\n  -h\t\tprint this help screen"
!         "\n  -C local:remote\tset permitted SSL ciphers for local:remote"
!         "\n  -K ip:port[,...]\tkerberized, (and regular) https ssl servers"
!         "\n  -P ip:port\tpre-existing https proxy"
!         "\n  -A (NS|MSIE)[Version]:(Cookie|Language|None)"
! 				"\tType of proxy port auth"
!         "\n  -S len,tries,cookie\tSpecify cookie, tries until shutdown, "
! 				"and/or length"
! 		"\n\t\t\tdefault bytes,tries,value = 8,5,<RANDOM>"
!         "\n  -I \t\tInsecure listening port - no cookie"
          "\n  -D level\tdebug level (0-7)  default: 5"
          "\n  -V\t\tprint stunnel version\n");
      exit(1);
diff -Nacr stunnel-3.8.orig/truerand.c stunnel-3.8/truerand.c
*** stunnel-3.8.orig/truerand.c	Wed Dec 31 19:00:00 1969
--- stunnel-3.8/truerand.c	Fri Jul 21 13:53:48 2000
***************
*** 0 ****
--- 1,480 ----
+ /*
+  *    Physically random numbers (very nearly uniform)
+  *      D. P. Mitchell 
+  *      Modified by Matt Blaze 2/95
+  *      Assembled and reformatted by Ralf S. Engelschall for mod_ssl
+  */
+ 
+ /*
+  * The authors of this software are Don Mitchell and Matt Blaze.
+  *              Copyright (c) 1995 by AT&T.
+  * Permission to use, copy, and modify this software without fee
+  * is hereby granted, provided that this entire notice is included in
+  * all copies of any software which is or includes a copy or
+  * modification of this software and in all copies of the supporting
+  * documentation for such software.
+  *
+  * This software may be subject to United States export controls.
+  *
+  * THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
+  * WARRANTY.  IN PARTICULAR, NEITHER THE AUTHORS NOR AT&T MAKE ANY
+  * REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
+  * OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
+  */
+ 
+ /*
+  * WARNING: depending on the particular platform, truerand() output may
+  * be biased or correlated.  In general, you can expect about 16 bits of
+  * "pseudo-entropy" out of each 32 bit word returned by truerand(),
+  * but it may not be uniformly diffused.  You should therefore run
+  * the output through some post-whitening function (like MD5 or DES or
+  * whatever) before using it to generate key material.  (RSAREF's
+  * random package does this for you when you feed truerand() bits to the
+  * seed input function.)
+  *
+  * Test these assumptions on your own platform before fielding a system
+  * based on this software or these techniques.
+  *
+  * This software seems to work well (at 16 bits per truerand() call) on
+  * a Sun Sparc-20 under SunOS 4.1.3 and on a P100 under BSDI 2.0.  You're
+  * on your own elsewhere.
+  */
+ 
+ #include <stdio.h>
+ #include <stdlib.h>
+ #include <signal.h>
+ #include <setjmp.h>
+ #include <math.h>
+ #include <sys/time.h>
+ 
+ static jmp_buf env;
+ static unsigned count;
+ static unsigned ocount;
+ static unsigned buffer;
+ 
+ static void tick(void)
+ {
+     struct itimerval it, oit;
+ 
+     timerclear(&it.it_interval);
+     it.it_value.tv_sec = 0;
+     it.it_value.tv_usec = 16665;
+     if (setitimer(ITIMER_REAL, &it, &oit) < 0)
+         perror("tick");
+ }
+ 
+ static void interrupt(int s)
+ {
+     if (count)
+         longjmp(env, 1);
+     (void) signal(SIGALRM, interrupt);
+     tick();
+ }
+ 
+ static unsigned long roulette(void)
+ {
+     if (setjmp(env)) {
+         count ^= (count >> 3) ^ (count >> 6) ^ ocount;
+         count &= 0x7;
+         ocount = count;
+         buffer = (buffer << 3) ^ count;
+         return buffer;
+     }
+     (void) signal(SIGALRM, interrupt);
+     count = 0;
+     tick();
+     for (;;)
+         count++; /* about 1 MHz on VAX 11/780 */
+ }
+ 
+ unsigned long truerand(void)
+ {
+     count = 0;
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     (void) roulette();
+     return roulette();
+ }
+ 
+ int n_truerand(int n)
+ {
+     int slop, v;
+ 
+     slop = 0x7FFFFFFF % n;
+     do {
+         v = truerand() >> 1;
+     } while (v <= slop);
+     return v % n;
+ }
+ 
+ /*
+  * Secure Hash Standard
+  * proposed NIST SHS
+  * coded for byte strings: number of bits is a multiple of 8
+  *
+  * Copyright (c) 1992, 1994 AT&T Bell Laboratories
+  * Coded by Jim Reeds 5 Feb 1992
+  * Enhanced by Jack Lacy 1993, 1994
+  */
+ 
+ /*
+  * unsigned char * shs(char *s, int n);
+  *
+  * input:  
+  *                s character array to be hashed
+  *                n length of s in BYTES
+  * output:
+  *                return value: address of 5 unsigned longs holding hash
+  *
+  * machine dependencies:
+  *                assumes a char is 8 bits
+  */
+ 
+ /*
+  * passes test on:
+  *                gauss (vax)
+  *                3k (cray)
+  *                slepian (MIPS)
+  *                bird (sparcstation II)
+  */
+ 
+ #include <sys/types.h>
+ #include <stdio.h>
+ 
+ typedef struct {
+     long totalLength;
+     unsigned long h[5];
+     unsigned long w[80];
+ } SHS_CTX;
+ 
+ unsigned char *shs();
+ #ifdef SOLARIS2X
+ #define bzero(b, l)             memset(b, 0, l)
+ #define bcopy(s, d, l)          memcpy(d, s, l)
+ #define bcmp(s, d, l)           (memcmp(s, d, l)? 1 : 0)
+ #endif
+ 
+ static long nbits;
+ static unsigned long *h;
+ static unsigned long *w;
+ static void shs1();
+ 
+ #define MASK        (unsigned long)0xffffffffL  /* in case more than 32 
+                                                    bits per long */
+ 
+ /*
+  * stick one byte into the current block; process the block when full
+  */
+ static void opack(unsigned char c)
+ {
+     int n32, nd32, shiftbits;
+     register unsigned long x, mask, y;
+ 
+     nd32 = (int) (nbits >> 5);  /* nbits/32 */
+     n32 = (int) (nbits & 0x1f); /* nbits%32 */
+     shiftbits = 24 - n32;
+ 
+     x = (unsigned long) (c << shiftbits);
+     mask = (unsigned long) (0xff << shiftbits);
+     mask = ~mask;
+ 
+     y = w[nd32];
+     y = (y & mask) + x;
+     w[nd32] = y;
+ 
+     nbits += 8;
+     if (nbits == 512) {
+         nbits = 0;
+         shs1();
+     }
+ }
+ 
+ static void pack(unsigned char c0, unsigned char c1, unsigned char c2, unsigned char c3)
+ {
+     int nd32;
+ 
+     nd32 = (int) (nbits >> 5);
+     w[nd32] = (u_long) (((u_long) c0 << 24) | ((u_long) c1 << 16) | ((u_long) c2 << 8) |
+                         (u_long) c3);
+     nbits += 32;
+     if (nbits == 512) {
+         nbits = 0;
+         shs1();
+     }
+ }
+ 
+ /*
+  * stick a 4 byte number into the current block
+  */
+ static void packl(unsigned long x)
+ {
+     pack((unsigned char) (x >> 24), (unsigned char) (x >> 16),
+          (unsigned char) (x >> 8), (unsigned char) (x >> 0));
+ }
+ 
+ /*
+  * process one block
+  */
+ static void shs1(void)
+ {
+     unsigned long *wp;
+     unsigned long temp;
+     unsigned long A, B, C, D, E;
+     int t;
+ 
+ #define S(n,x) (u_long)(((x)<<(n))|((MASK&(x))>>(32-(n))))
+ 
+     wp = w;
+     t = 8;
+     do {
+         wp[16] = S(1, (u_long) (wp[13] ^ wp[8] ^ wp[2] ^ wp[0]));
+         wp[17] = S(1, (u_long) (wp[14] ^ wp[9] ^ wp[3] ^ wp[1]));
+         wp[18] = S(1, (u_long) (wp[15] ^ wp[10] ^ wp[4] ^ wp[2]));
+         wp[19] = S(1, (u_long) (wp[16] ^ wp[11] ^ wp[5] ^ wp[3]));
+         wp[20] = S(1, (u_long) (wp[17] ^ wp[12] ^ wp[6] ^ wp[4]));
+         wp[21] = S(1, (u_long) (wp[18] ^ wp[13] ^ wp[7] ^ wp[5]));
+         wp[22] = S(1, (u_long) (wp[19] ^ wp[14] ^ wp[8] ^ wp[6]));
+         wp[23] = S(1, (u_long) (wp[20] ^ wp[15] ^ wp[9] ^ wp[7]));
+         wp += 8;
+         t--;
+     } while (t > 0);
+ 
+     A = h[0];
+     B = h[1];
+     C = h[2];
+     D = h[3];
+     E = h[4];
+ 
+     t = 0;
+     while (t < 20) {
+         temp = S(5, A) + E + w[t++];
+         temp += (unsigned long) 0x5a827999L + ((B & C) | (D & ~B));
+         E = D;
+         D = C;
+         C = S(30, B);
+         B = A;
+         A = temp;
+     }
+     while (t < 40) {
+         temp = S(5, A) + E + w[t++];
+         temp += (unsigned long) 0x6ed9eba1L + (B ^ C ^ D);
+         E = D;
+         D = C;
+         C = S(30, B);
+         B = A;
+         A = temp;
+     }
+     while (t < 60) {
+         temp = S(5, A) + E + w[t++];
+         temp += (unsigned long) 0x8f1bbcdcL + ((B & C) | (B & D) | (C & D));
+         E = D;
+         D = C;
+         C = S(30, B);
+         B = A;
+         A = temp;
+     }
+     while (t < 80) {
+         temp = S(5, A) + E + w[t++];
+         temp += (unsigned long) 0xca62c1d6L + (B ^ C ^ D);
+         E = D;
+         D = C;
+         C = S(30, B);
+         B = A;
+         A = temp;
+     }
+     h[0] = MASK & (h[0] + A);
+     h[1] = MASK & (h[1] + B);
+     h[2] = MASK & (h[2] + C);
+     h[3] = MASK & (h[3] + D);
+     h[4] = MASK & (h[4] + E);
+ }
+ 
+ #define CHARSTOLONG(wp,s,i) \
+         {*wp++ = \
+           (u_long)((((u_long)(s[i])&0xff)<<24)| \
+          (((u_long)(s[i+1])&0xff)<<16)| \
+          (((u_long)(s[i+2])&0xff)<<8)| \
+          (u_long)(s[i+3]&0xff));}
+ 
+ void shsInit(SHS_CTX *mdContext)
+ {
+     nbits = 0;
+     mdContext->h[0] = (unsigned long) 0x67452301L;
+     mdContext->h[1] = (unsigned long) 0xefcdab89L;
+     mdContext->h[2] = (unsigned long) 0x98badcfeL;
+     mdContext->h[3] = (unsigned long) 0x10325476L;
+     mdContext->h[4] = (unsigned long) 0xc3d2e1f0L;
+     mdContext->totalLength = 0;
+ }
+ 
+ void shsUpdate(SHS_CTX *mdContext, unsigned char *s, unsigned int n)
+ {
+     register unsigned long *wp;
+     long nn = n;
+     long i;
+ 
+     w = mdContext->w;
+     h = mdContext->h;
+     mdContext->totalLength += n;
+ 
+     nbits = 0;
+     n = n / (u_long) 64;
+     wp = w;
+ 
+     while (n > 0) {
+         CHARSTOLONG(wp, s, 0);
+         CHARSTOLONG(wp, s, 4);
+         CHARSTOLONG(wp, s, 8);
+         CHARSTOLONG(wp, s, 12);
+         CHARSTOLONG(wp, s, 16);
+         CHARSTOLONG(wp, s, 20);
+         CHARSTOLONG(wp, s, 24);
+         CHARSTOLONG(wp, s, 28);
+         CHARSTOLONG(wp, s, 32);
+         CHARSTOLONG(wp, s, 36);
+         CHARSTOLONG(wp, s, 40);
+         CHARSTOLONG(wp, s, 44);
+         CHARSTOLONG(wp, s, 48);
+         CHARSTOLONG(wp, s, 52);
+         CHARSTOLONG(wp, s, 56);
+         CHARSTOLONG(wp, s, 60);
+         n--;
+         wp = w;
+         s = (s + 64);
+         shs1();
+     }
+     i = nn % 64;
+     while (i > 3) {
+         CHARSTOLONG(wp, s, 0);
+         s = (s + 4);
+         nbits += (u_long) 32;
+         i -= 4;
+     }
+     while (i) {
+         opack((unsigned char) *s++);
+         i--;
+     }
+ }
+ 
+ void shsFinal(SHS_CTX *mdContext)
+ {
+     long nn = mdContext->totalLength;
+     w = mdContext->w;
+     h = mdContext->h;
+ 
+     opack(128);
+     while (nbits != 448)
+         opack(0);
+     packl((unsigned long) (nn >> 29));
+     packl((unsigned long) (nn << 3));
+ 
+     /* if(nbits != 0)
+        handle_exception(CRITICAL,"shsFinal(): nbits != 0\n"); */
+ }
+ 
+ unsigned char *shs(unsigned char *s, long n)
+ {
+     SHS_CTX *mdContext;
+     static SHS_CTX mdC;
+     static unsigned char ret[20];
+     int i;
+ 
+     mdContext = &mdC;
+ 
+     shsInit(mdContext);
+     shsUpdate(mdContext, s, n);
+     shsFinal(mdContext);
+     for (i = 0; i < 5; i++) {
+         ret[i * 4] = (mdContext->h[i] >> 24) & 0xff;
+         ret[i * 4 + 1] = (mdContext->h[i] >> 16) & 0xff;
+         ret[i * 4 + 2] = (mdContext->h[i] >> 8) & 0xff;
+         ret[i * 4 + 3] = (mdContext->h[i]) & 0xff;
+     }
+ 
+     return ret;
+ }
+ 
+ unsigned long *fShsDigest(FILE *in)
+ {
+     SHS_CTX *mdContext;
+     SHS_CTX mdC;
+     unsigned char buffer[1024];
+     long length, total;
+ 
+     mdContext = &mdC;
+ 
+     bzero(buffer, 1024);
+ 
+     total = 0;
+     shsInit(mdContext);
+     while ((length = fread(buffer, 1, 1024, in)) != 0) {
+         total += length;
+         shsUpdate(mdContext, buffer, length);
+     }
+     shsFinal(mdContext);
+ 
+     return mdContext->h;
+ }
+ 
+ /*
+  *    Random byte interface to truerand()
+  *      Matt Blaze 5/95
+  *      eight really random bits
+  *      usage: 
+  *              unsigned char r; int randbyte();
+  *              r=randbyte();
+  *      randbyte() takes about .3 seconds on most machines.
+  */
+ 
+ int randbyte(void)
+ {
+     unsigned long truerand();
+     unsigned char *shs();
+     unsigned long r[2];
+     unsigned char *hash;
+ 
+     r[0] = truerand();
+     r[1] = truerand();
+     hash = shs((unsigned char *)r, (long)sizeof(r));
+ #ifdef DEBUGRND
+     printf("%011o %011o %02x\n", r[0], r[1], *hash & 0xff);
+ #endif
+     return ((int) (*hash)) & 0xff;
+ }
+ 
+ /*
+  * Main program
+  */
+ 
+ /* SIGPIPE causes normal exit */
+ 
+ /*
+ **
+ static void handler(int sig)
+ {
+     exit(0);
+ }
+ 
+ int main(int argc, char **argv)
+ {
+     int count;
+ 
+     signal(SIGPIPE, handler);
+     if (argc == 1)
+         count = 0;
+     else
+         count = atoi(argv[1]) + 1;
+     setbuf(stdout, NULL);
+     while (--count)
+         fprintf(stdout, "%c", randbyte());
+ }
+ 
+ **
+ */
